﻿using AsmodeeDigital.PlayReal.Plugin.Domain.GameState;
using ProtoBuf;
using System;
using System.Collections.Generic;

namespace AsmodeeDigital.PlayReal.Samples.Domain.GameState.Events
{
    /// <summary>
    /// Event used for multicast ui refresh
    /// </summary>
    [ProtoContract, Serializable]
    public class DiceSelected : IEvent
    {
        /// <summary>
        /// Player local ID
        /// </summary>
        [ProtoMember(1)]
        public int PlayerLocalID { get; set; }

        /// <summary>
        /// UTC time
        /// </summary>
        [ProtoMember(2)]
        public long Time { get; set; }

        /// <summary>
        /// List of selected state for each dice. True the dice is selected, False it is not
        /// </summary>
        [ProtoMember(3)]
        public List<bool> SelectedDice = new List<bool>();

        public DiceSelected()
        {
        }

        public DiceSelected(int playerLocalID, List<bool> DiceInDiceSelected)
        {
            PlayerLocalID = playerLocalID;
            SelectedDice.AddRange(DiceInDiceSelected);

            Time = DateTime.Now.Ticks;
        }
    }
}
